complete -c kbs2 -n "__fish_use_subcommand" -s c -l config-dir -d 'use the specified config directory' -r -f -a "(__fish_complete_directories)"
complete -c kbs2 -n "__fish_use_subcommand" -l completions -d 'emit shell tab completions' -r -f -a "{bash	,elvish	,fish	,powershell	,zsh	}"
complete -c kbs2 -n "__fish_use_subcommand" -s h -l help -d 'Print help information'
complete -c kbs2 -n "__fish_use_subcommand" -s V -l version -d 'Print version information'
complete -c kbs2 -n "__fish_use_subcommand" -f -a "agent" -d 'run the kbs2 authentication agent'
complete -c kbs2 -n "__fish_use_subcommand" -f -a "init" -d 'initialize kbs2 with a new config and keypair'
complete -c kbs2 -n "__fish_use_subcommand" -f -a "new" -d 'create a new record'
complete -c kbs2 -n "__fish_use_subcommand" -f -a "list" -d 'list records'
complete -c kbs2 -n "__fish_use_subcommand" -f -a "rm" -d 'remove one or more records'
complete -c kbs2 -n "__fish_use_subcommand" -f -a "dump" -d 'dump one or more records'
complete -c kbs2 -n "__fish_use_subcommand" -f -a "pass" -d 'get the password in a login record'
complete -c kbs2 -n "__fish_use_subcommand" -f -a "env" -d 'get an environment record'
complete -c kbs2 -n "__fish_use_subcommand" -f -a "edit" -d 'modify a record with a text editor'
complete -c kbs2 -n "__fish_use_subcommand" -f -a "generate" -d 'generate secret values using a generator'
complete -c kbs2 -n "__fish_use_subcommand" -f -a "rewrap" -d 'change the master password on a wrapped key'
complete -c kbs2 -n "__fish_use_subcommand" -f -a "rekey" -d 're-encrypt the entire store with a new keypair and master password'
complete -c kbs2 -n "__fish_use_subcommand" -f -a "config" -d 'interact with kbs2\'s configuration file'
complete -c kbs2 -n "__fish_use_subcommand" -f -a "help" -d 'Print this message or the help of the given subcommand(s)'
complete -c kbs2 -n "__fish_seen_subcommand_from agent; and not __fish_seen_subcommand_from flush; and not __fish_seen_subcommand_from query; and not __fish_seen_subcommand_from unwrap; and not __fish_seen_subcommand_from help" -s F -l foreground -d 'run the agent in the foreground'
complete -c kbs2 -n "__fish_seen_subcommand_from agent; and not __fish_seen_subcommand_from flush; and not __fish_seen_subcommand_from query; and not __fish_seen_subcommand_from unwrap; and not __fish_seen_subcommand_from help" -s h -l help -d 'Print help information'
complete -c kbs2 -n "__fish_seen_subcommand_from agent; and not __fish_seen_subcommand_from flush; and not __fish_seen_subcommand_from query; and not __fish_seen_subcommand_from unwrap; and not __fish_seen_subcommand_from help" -f -a "flush" -d 'remove all unwrapped keys from the running agent'
complete -c kbs2 -n "__fish_seen_subcommand_from agent; and not __fish_seen_subcommand_from flush; and not __fish_seen_subcommand_from query; and not __fish_seen_subcommand_from unwrap; and not __fish_seen_subcommand_from help" -f -a "query" -d 'ask the current agent whether it has the current config\'s key'
complete -c kbs2 -n "__fish_seen_subcommand_from agent; and not __fish_seen_subcommand_from flush; and not __fish_seen_subcommand_from query; and not __fish_seen_subcommand_from unwrap; and not __fish_seen_subcommand_from help" -f -a "unwrap" -d 'unwrap the current config\'s key in the running agent'
complete -c kbs2 -n "__fish_seen_subcommand_from agent; and not __fish_seen_subcommand_from flush; and not __fish_seen_subcommand_from query; and not __fish_seen_subcommand_from unwrap; and not __fish_seen_subcommand_from help" -f -a "help" -d 'Print this message or the help of the given subcommand(s)'
complete -c kbs2 -n "__fish_seen_subcommand_from agent; and __fish_seen_subcommand_from flush" -s q -l quit -d 'quit the agent after flushing'
complete -c kbs2 -n "__fish_seen_subcommand_from agent; and __fish_seen_subcommand_from flush" -s h -l help -d 'Print help information'
complete -c kbs2 -n "__fish_seen_subcommand_from agent; and __fish_seen_subcommand_from query" -s h -l help -d 'Print help information'
complete -c kbs2 -n "__fish_seen_subcommand_from agent; and __fish_seen_subcommand_from unwrap" -s h -l help -d 'Print help information'
complete -c kbs2 -n "__fish_seen_subcommand_from init" -s s -l store-dir -d 'the directory to store encrypted kbs2 records in' -r -f -a "(__fish_complete_directories)"
complete -c kbs2 -n "__fish_seen_subcommand_from init" -s f -l force -d 'overwrite the config and keyfile, if already present'
complete -c kbs2 -n "__fish_seen_subcommand_from init" -l insecure-not-wrapped -d 'don\'t wrap the keypair with a master password'
complete -c kbs2 -n "__fish_seen_subcommand_from init" -s h -l help -d 'Print help information'
complete -c kbs2 -n "__fish_seen_subcommand_from new" -s k -l kind -d 'the kind of record to create' -r -f -a "{login	,environment	,unstructured	}"
complete -c kbs2 -n "__fish_seen_subcommand_from new" -s G -l generator -d 'use the given generator to generate sensitive fields' -r
complete -c kbs2 -n "__fish_seen_subcommand_from new" -s f -l force -d 'overwrite, if already present'
complete -c kbs2 -n "__fish_seen_subcommand_from new" -s t -l terse -d 'read fields in a terse format, even when connected to a tty'
complete -c kbs2 -n "__fish_seen_subcommand_from new" -s h -l help -d 'Print help information'
complete -c kbs2 -n "__fish_seen_subcommand_from list" -s k -l kind -d 'list only records of this kind' -r -f -a "{login	,environment	,unstructured	}"
complete -c kbs2 -n "__fish_seen_subcommand_from list" -s d -l details -d 'print (non-field) details for each record'
complete -c kbs2 -n "__fish_seen_subcommand_from list" -s h -l help -d 'Print help information'
complete -c kbs2 -n "__fish_seen_subcommand_from rm" -s h -l help -d 'Print help information'
complete -c kbs2 -n "__fish_seen_subcommand_from dump" -s j -l json -d 'dump in JSON format (JSONL when multiple)'
complete -c kbs2 -n "__fish_seen_subcommand_from dump" -s h -l help -d 'Print help information'
complete -c kbs2 -n "__fish_seen_subcommand_from pass" -s c -l clipboard -d 'copy the password to the clipboard'
complete -c kbs2 -n "__fish_seen_subcommand_from pass" -s h -l help -d 'Print help information'
complete -c kbs2 -n "__fish_seen_subcommand_from env" -s v -l value-only -d 'print only the environment variable value, not the variable name'
complete -c kbs2 -n "__fish_seen_subcommand_from env" -s n -l no-export -d 'print only VAR=val without `export`'
complete -c kbs2 -n "__fish_seen_subcommand_from env" -s h -l help -d 'Print help information'
complete -c kbs2 -n "__fish_seen_subcommand_from edit" -s p -l preserve-timestamp -d 'don\'t update the record\'s timestamp'
complete -c kbs2 -n "__fish_seen_subcommand_from edit" -s h -l help -d 'Print help information'
complete -c kbs2 -n "__fish_seen_subcommand_from generate" -s h -l help -d 'Print help information'
complete -c kbs2 -n "__fish_seen_subcommand_from rewrap" -s n -l no-backup -d 'don\'t make a backup of the old wrapped key'
complete -c kbs2 -n "__fish_seen_subcommand_from rewrap" -s f -l force -d 'overwrite a previous backup, if one exists'
complete -c kbs2 -n "__fish_seen_subcommand_from rewrap" -s h -l help -d 'Print help information'
complete -c kbs2 -n "__fish_seen_subcommand_from rekey" -s n -l no-backup -d 'don\'t make a backup of the old wrapped key, config, or store'
complete -c kbs2 -n "__fish_seen_subcommand_from rekey" -s h -l help -d 'Print help information'
complete -c kbs2 -n "__fish_seen_subcommand_from config; and not __fish_seen_subcommand_from dump; and not __fish_seen_subcommand_from help" -s h -l help -d 'Print help information'
complete -c kbs2 -n "__fish_seen_subcommand_from config; and not __fish_seen_subcommand_from dump; and not __fish_seen_subcommand_from help" -f -a "dump" -d 'dump the active configuration file as JSON'
complete -c kbs2 -n "__fish_seen_subcommand_from config; and not __fish_seen_subcommand_from dump; and not __fish_seen_subcommand_from help" -f -a "help" -d 'Print this message or the help of the given subcommand(s)'
complete -c kbs2 -n "__fish_seen_subcommand_from config; and __fish_seen_subcommand_from dump" -s p -l pretty -d 'pretty-print the JSON'
complete -c kbs2 -n "__fish_seen_subcommand_from config; and __fish_seen_subcommand_from dump" -s h -l help -d 'Print help information'
